<?php
/**
* @package language(permissions)
* @version $Id: permissions_blog.php 485 2008-08-15 23:33:57Z exreaction@gmail.com $
* @copyright (c) 2008 EXreaction, Lithium Studios
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*/

// Create the lang array if it does not already exist
if (empty($lang) || !is_array($lang))
{
	$lang = array();
}

// Create a new category named Blog
$lang['permission_cat']['blog'] = 'Blog';

// User Permissions
$lang = array_merge($lang, array(
	'acl_u_blogview'			=> array('lang' => 'Puede ver las entradas del blog', 'cat' => 'blog'),
	'acl_u_blogpost'			=> array('lang' => 'De enviar las entradas del blog', 'cat' => 'blog'),
	'acl_u_blogedit'			=> array('lang' => 'Puede editar sus propias entradas del blog', 'cat' => 'blog'),
	'acl_u_blogdelete'			=> array('lang' => 'Puede eliminar entradas propias del blog', 'cat' => 'blog'),
	'acl_u_blognoapprove'		=> array('lang' => 'Las entradas de blog no necesitan la aprobación antes de la visión pública', 'cat' => 'blog'),
	'acl_u_blogreport'			=> array('lang' => 'Puede informar las entradas y respuestas del blog', 'cat' => 'blog'),
	'acl_u_blogreply'			=> array('lang' => 'Puede hacer comentarios sobre las entradas del blog', 'cat' => 'blog'),
	'acl_u_blogreplyedit'		=> array('lang' => 'Puede editar los comentarios propios', 'cat' => 'blog'),
	'acl_u_blogreplydelete'		=> array('lang' => 'Puede eliminar comentarios propios', 'cat' => 'blog'),
	'acl_u_blogreplynoapprove'	=> array('lang' => 'Comentarios no necesitan la aprobación antes de la visión pública', 'cat' => 'blog'),
	'acl_u_blogbbcode'			=> array('lang' => 'Puede usar BBCode en entradas y comentarios del blog', 'cat' => 'blog'),
	'acl_u_blogsmilies'			=> array('lang' => 'Puede usar emoticones en entradas y comentarios del blog', 'cat' => 'blog'),
	'acl_u_blogimg'				=> array('lang' => 'Puede enviar imágenes en entradas y comentarios del blog', 'cat' => 'blog'),
	'acl_u_blogurl'				=> array('lang' => 'Puede usar URLs en entradas y comentarios del blog', 'cat' => 'blog'),
	'acl_u_blogflash'			=> array('lang' => 'Puede usar flash en entradas y comentarios del blog', 'cat' => 'blog'),
	'acl_u_blogmoderate'		=> array('lang' => 'Puede moderar (Editar y eliminar) comentarios del blog propio.', 'cat' => 'blog'),
	'acl_u_blogattach'			=> array('lang' => 'Puede enviar archivos adjuntos en entradas y comentarios del blog', 'cat' => 'blog'),
	'acl_u_blognolimitattach'	=> array('lang' => 'Puede pasar por alto el tamaño y limite de los archivos adjuntos', 'cat' => 'blog'),

	'acl_u_blog_create_poll'	=> array('lang' => 'Puede crear encuestas', 'cat' => 'blog'),
	'acl_u_blog_vote'			=> array('lang' => 'Pueden votar en las encuestas', 'cat' => 'blog'),
	'acl_u_blog_vote_change'	=> array('lang' => 'Puede cambiar el voto existente', 'cat' => 'blog'),
	'acl_u_blog_style'			=> array('lang' => 'Puede seleccionar un estilo a utilizar para su propio blog', 'cat' => 'blog'),
	'acl_u_blog_css'			=> array('lang' => 'Puede entrar en su propio código CSS para personalizar su estilo de blog de la manera que desea.', 'cat' => 'blog'),
));

// Moderator Permissions
$lang = array_merge($lang, array(
	'acl_m_blogapprove'			=> array('lang' => 'Puede ver las entradas de blog no aprobados y aprobar la vista al público', 'cat' => 'blog'),
	'acl_m_blogedit'			=> array('lang' => 'Puede editar las entradas del blog', 'cat' => 'blog'),
	'acl_m_bloglockedit'		=> array('lang' => 'Puede bloquear la edición de entradas del blog', 'cat' => 'blog'),
	'acl_m_blogdelete'			=> array('lang' => 'Puede eliminar y recuperar entradas de blog', 'cat' => 'blog'),
	'acl_m_blogreport'			=> array('lang' => 'Puede cerrar y eliminar los informes de entrada del blog.', 'cat' => 'blog'),
	'acl_m_blogreplyapprove'	=> array('lang' => 'Puede ver los comentarios no aprobados y aprobar los comentarios para la visión pública', 'cat' => 'blog'),
	'acl_m_blogreplyedit'		=> array('lang' => 'Puede editar los comentarios', 'cat' => 'blog'),
	'acl_m_blogreplylockedit'	=> array('lang' => 'Puede bloquear la edición de comentarios', 'cat' => 'blog'),
	'acl_m_blogreplydelete'		=> array('lang' => 'Puede eliminar y recuperar los comentarios', 'cat' => 'blog'),
	'acl_m_blogreplyreport'		=> array('lang' => 'Puede cerrar y eliminar los informes comentario.', 'cat' => 'blog'),
));

// Administrator Permissions
$lang = array_merge($lang, array(
	'acl_a_blogmanage'			=> array('lang' => 'Puede cambiar la configuración del blog', 'cat' => 'blog'),
	'acl_a_blogdelete'			=> array('lang' => 'Puede eliminar permanentemente entradas del blog', 'cat' => 'blog'),
	'acl_a_blogreplydelete'		=> array('lang' => 'Puede eliminar permanentemente los comentarios en las entradas del blog', 'cat' => 'blog'),
));
?>