<?php
/**
*
* @package phpBB3 User Blog
* @version $Id: posting.php 485 2008-08-15 23:33:57Z exreaction@gmail.com $
* @copyright (c) 2008 EXreaction, Lithium Studios
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

// Create the lang array if it does not already exist
if (empty($lang) || !is_array($lang))
{
	$lang = array();
}

// Merge the following language entries into the lang array
$lang = array_merge($lang, array(
	'ADD_BLOG'					=> 'Agregar una entrada de blog nueva',
	'APPROVE_BLOG'				=> 'Aprobar entrada de blog',
	'APPROVE_BLOG_CONFIRM'		=> 'Ests seguro de que desea aprobar esta entrada del blog?',
	'APPROVE_BLOG_SUCCESS'		=> 'Ha aprobado esta entrada del blog para la visin pblica.',
	'APPROVE_REPLY'				=> 'Aprobar comentario',
	'APPROVE_REPLY_CONFIRM'		=> 'Ests seguro de que desea aprobar este comentario?',
	'APPROVE_REPLY_SUCCESS'		=> 'Ha aprobado este comentario para la visin pblica.',

	'BLOG_ALREADY_APPROVED'		=> 'Esta entrada del blog ya est aprobada.',
	'BLOG_ALREADY_DELETED'		=> 'Esta entrada del blog ya se ha eliminado.',
	'BLOG_APPROVE_PM'			=> 'Este es un mensaje automtico enviado por el mod blog de usuario.<br /><br />%1$s se acaba de publicar <a href="%2$s">esta entrada del blog</a> y se necesita la aprobacin antes de que sea pblicamente visible.<br />Por favor tmese el tiempo para leer sobre la entrada de blog y decidir qu hay que hacer.',
	'BLOG_APPROVE_PM_SUBJECT'	=> 'Autorizacin de entrada de blog necesaria!',
	'BLOG_DELETED'				=> 'Entrada de blog se ha eliminado.',
	'BLOG_EDIT_LOCKED'			=> 'Esta entrada del blog est bloqueado para su edicin.',
	'BLOG_EDIT_SUCCESS'			=> 'La entrada de blog fue editado con xito!',
	'BLOG_NEED_APPROVE'			=> 'Un administrador o moderador debe aprobar entradas de su blog antes de que sean pblicas.',
	'BLOG_NOT_DELETED'			=> 'Esta entrada del blog no esta elimina. Por qu ests tratando de recuperarla?',
	'BLOG_REPORT_CONFIRM'		=> 'Ests seguro de que desea informar sobre esta entrada en el blog?',
	'BLOG_REPORT_PM'			=> 'Este es un mensaje automtico enviado por el mod blog de usuario.<br /><br />%1$s acaba de informar <a href="%2$s">esta entrada del blog </a>.<br />Por favor tmese el tiempo para leer sobre la entrada de blog y decidir qu hay que hacer.',
	'BLOG_REPORT_PM_SUBJECT'	=> 'Entrada del blog reportada!',
	'BLOG_SUBMIT_SUCCESS'		=> 'La entrada de blog fue enviada con xito!',
	'BLOG_SUBSCRIPTION_NOTICE'	=> 'Este es un mensaje automtico enviado desde el mod blog de usuario, le notifica que un comentario se ha hecho para [url=%1$s]esta[/url] entrada de blog por %2$s.<br /><br />Si no desea recibir estas notificaciones, haga clic [url=%3$s]aqui[/url] para eliminar su suscripcin.',
	'BLOG_UNDELETED'			=> 'La entrada de blog ha sido recuperada.',

	'CATEGORY_EXPLAIN'			=> 'Usted puede seleccionar ms de una categora presionando CTRL y haciendo clic en varias categoras a las que le gustara entrar.<br /><br />Entradas de blogs son <strong>siempre</strong> se muestra en su blog personal.',

	'DELETE_BLOG_CONFIRM'		=> 'Ests seguro de que quieres eliminar esta entrada del blog?',
	'DELETE_REPLY_CONFIRM'		=> 'Ests seguro de que deseas eliminar este comentario?',

	'EDIT_A_BLOG'				=> 'Editar una entrada de blog',
	'EDIT_A_REPLY'				=> 'Editar un comentario',

	'HARD_DELETE'				=> 'Eliminar definitivamente',
	'HARD_DELETE_EXPLAIN'		=> 'Si selecciona esto, ya no podra recuperar el mensaje!',

	'NO_PERMISSIONS_SINGLE'		=> 'No se puede leer o responder a esta entrada del blog.',

	'PERMISSIONS'				=> 'Permisos',

	'REPLY_ALREADY_APPROVED'	=> 'Este comentario ya ha sido aprobado.',
	'REPLY_APPROVE_PM'			=> 'Este es un mensaje automtico enviado por el mod del blog de usuario.<br /><br />%1$s se acaba de publicar <a href="%2$s">este comentario</a> y se necesita la aprobacin antes de que sea pblicamente visible.<br />Por favor tmese el tiempo de leer el comentario y decidir qu hay que hacer.',
	'REPLY_APPROVE_PM_SUBJECT'	=> 'Aprobacin de un comentario de blog necesario!',
	'REPLY_DELETED'				=> 'Comentario se ha eliminado.',
	'REPLY_EDIT_LOCKED'			=> 'Este comentario est bloqueado para su edicin.',
	'REPLY_EDIT_SUCCESS'		=> 'El comentario ha sido editado con xito!',
	'REPLY_NEED_APPROVE'		=> 'Un administrador o moderador debe aprobar el comentario antes de que sea publicado.',
	'REPLY_NOT_DELETED'			=> 'Este comentario no esta borrado. Por qu ests tratando de recuperarlo?',
	'REPLY_PERMISSIONS_SINGLE'	=> 'Puede leer y responder a esta entrada del blog.',
	'REPLY_REPORT_CONFIRM'		=> 'Est seguro de que desea reportar este comentario?',
	'REPLY_REPORT_PM'			=> 'Este es un mensaje automtico enviado por el mod del blog de usuario.<br /><br />%1$s se acaba de publicar <a href="%2$s">este comentario</a>.<br />Por favor tmese el tiempo de leer el comentario y decidir qu hay que hacer.',
	'REPLY_REPORT_PM_SUBJECT'	=> 'Comentario del blog reportado!',
	'REPLY_SUBMIT_SUCCESS'		=> 'El comentario se ha enviado con xito!',
	'REPLY_UNDELETED'			=> 'El comentario ha sido recuperado.',

	'SUBSCRIPTION_NOTICE'		=> 'Aviso de suscripcin del mod blog de usuario',

	'UNDELETE_BLOG'				=> 'Recuperar la entrada de blog',
	'UNDELETE_BLOG_CONFIRM'		=> 'Ests seguro de que desea recuperar esta entrada del blog?',
	'UNDELETE_REPLY'			=> 'Recuperar comentario',
	'UNDELETE_REPLY_CONFIRM'	=> 'Est seguro de que desea recuperar este comentario?',
	'USER_SUBSCRIPTION_NOTICE'	=> 'Este es un mensaje automtico enviado desde el mod blog del usuario que le notifica que una entrada en el nuevo blog ha sido enviado por %1$s.  Puedes ver el blog [url=%2$s]aqui[/url].<br /><br />Si no desea recibir estas notificaciones, haga clic [url=%3$s]aqui[/url] para eliminar su suscripcin.',

	'VIEW_PERMISSIONS_SINGLE'	=> 'Puede leer esta entrada del blog.',
));

?>