<?php
/**
*
* @package phpBB3 User Blog
* @version $Id: setup.php 485 2008-08-15 23:33:57Z exreaction@gmail.com $
* @copyright (c) 2008 EXreaction, Lithium Studios
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

// Create the lang array if it does not already exist
if (empty($lang) || !is_array($lang))
{
	$lang = array();
}

// Merge the following language entries into the lang array
$lang = array_merge($lang, array(
	'ALREADY_INSTALLED'				=> 'Usted ya ha instalado el mod blog de usuario.<br /><br />Click %saqui%s para volver a la página principal del blog.',
	'ALREADY_UPDATED'				=> 'Se está ejecutando la última versión de el mod blog de usuario.<br /><br />Click %saqui%s para volver a la página principal del blog.',

	'BACKUP_NOTICE'					=> 'Asegúrese de hacer una copia de todos sus datos de ambos foros antes de intentar la actualización.  Si algo sale mal durante el proceso de actualización y no tienes la copia de los datos puedes perder todo.',

	'CLEANUP'						=> 'Limpiar',
	'CLEANUP_COMPLETE'				=> 'Las tablas se han limpiado con éxito.',
	'CONVERTED_BLOG_IDS_MISSING'	=> 'No se encontraron los ids del cache para la actualización del blog.  Por favor, restaure los datos de copia de seguridad de la base de datos y vuelva a intentar la actualización.',
	'CONVERT_COMPLETE'				=> 'El proceso de conversión se ha realizado correctamente.',
	'CONVERT_FOES'					=> 'Convertir Ignorados',
	'CONVERT_FOES_EXPLAIN'			=> 'Convierte los usuarios en el weblog_blocked a los enemigos.',
	'CONVERT_FRIENDS'				=> 'Convertir amigos',
	'CONVERT_FRIENDS_EXPLAIN'		=> 'Convierte los usuarios en el weblog_friends a tus amigos.',

	'DB_TABLE_NOT_EXIST'			=> 'La %s tabla no está en la base de datos seleccionada.',

	'FINAL'							=> 'Final',

	'INDEX_COMPLETE'				=> 'Los blogs y las respuestas han sido indexados por el sistema de búsqueda.',
	'INSTALL_BLOG_DB'				=> 'Instalar el mod blog de usuario',
	'INSTALL_BLOG_DB_CONFIRM'		=> '¿Estás listo para instalar la sección de base de datos de este mod?',
	'INSTALL_BLOG_DB_FAIL'			=> 'La instalación del mod ha fallado.<br />Por favor, informe los errores siguientes a EXreaction:<br />',
	'INSTALL_BLOG_DB_SUCCESS'		=> 'Ha instalado con éxito la sección de base de datos del mod.<br /><br />Click %saqui%s para volver a la página principal del blog de usuario.',

	'LIMIT_EXPLAIN'					=> 'Número de articulos para hacer a la vez.  Si establece esta demasiado alto puede tener que volver a hacer la actualización completa, pero, el más bajo sea el más largo de la actualización se llevará.',
	'LIMIT_INCORRECT'				=> 'Usted debe dar un limite de al menos 1.  Es altamente recomendable que utilice al menos 100 para esto, pero probablemente no más de 1000, dependiendo de su configuración de PHP.',

	'NEXT_PART'						=> 'Pasar a la siguiente parte',
	'NOT_INSTALLED'					=> 'Debe instalar el Mod blog del usuario antes de ejecutar el script de actualización.',
	'NO_STAGE'						=> 'No ha dado un escenario para trabajar.',

	'PRE_UPGRADE_COMPLETE'			=> 'Todas las fases anteriores a la conversión se han llevado a cabo con éxito. Usted puede ahora iniciar el proceso de conversión actual. Tenga en cuenta que puede que tenga que hacer manualmente y ajustar varias cosas después de la conversión automática, especialmente comprobar los permisos asignados.',

	'REINDEX'						=> 'Volver a indexar',
	'RESYNC'						=> 'Resincronización',
	'RESYNC_COMPLETE'				=> 'El Mod blog del usuario ha sido resincronizado.',
	'RETURN_LAST_STEP'				=> 'Haga clic aquí para volver a la última etapa.',

	'SCHEMA_NOT_EXIST'				=> 'El archivo instalación esquema de la base de datos no se encontro.  Por favor, descargue una copia nueva de este mod y vuelva a subit todos los archivos necesarios. Si esto no soluciona el problema, póngase en contacto con EXreaction.',
	'SEARCH_BREAK_CONTINUE_NOTICE'	=> 'Sección %1$s de %2$s, Parte %3$s de %4$s se ha completado, pero hay más secciones y / o partes que deben ser terminados antes de que todo se complete.<br />Haga clic en Continuar abajo si no se redirigen automáticamente a la página siguiente.',
	'SUCCESS'						=> 'Éxito',
	'SUCCESSFULLY_UPDATED'			=> 'El mod blog de usuario ha sido actualizado a %1$s.<br /><br />Click %2$saqui%3$s para volver a la página principal del blog.',

	'TRUNCATE_TABLES'				=> 'Truncar tablas existentes',
	'TRUNCATE_TABLES_EXPLAIN'		=> 'Esto borrará todos los datos existentes en las tablas del mod blog de usuario. Si selecciona No, los datos nuevos se añadirán a lo largo de sus blogs existentes y las respuestas.',

	'UNINSTALL_BLOG_DB'				=> 'Desinstalar el mod blog de usuario',
	'UNINSTALL_BLOG_DB_CONFIRM'		=> '¿Está seguro que desea eliminar el blog de datos del mod blog de usuario?<br /><br /><strong>Si usted hace esto TODOS los datos del Mod blog del usuario se pierden.</strong>',
	'UNINSTALL_BLOG_DB_SUCCESS'		=> 'Los datos del mod blog de usuario ha sido eliminado de la base de datos. Para eliminar completamente el Mod blog del usuario debe deshacer todos los cambios y eliminar cualquier archivo que ha agregado durante la instalación.',
	'UPDATE_INSTRUCTIONS'			=> 'Actualizar',
	'UPDATE_INSTRUCTIONS_CONFIRM'	=> 'Asegúrese de leer las instrucciones de actualización en la sección de Historia MOD dentro del documento principal de instalación<b>antes</b> de hacer esto.<br /><br />¿Estás listo para actualizar la base de datos para el Mod blog del usuario?',
	'UPGRADE_BLOGS'					=> 'Actualizar blogs',
	'UPGRADE_BREAK_CONTINUE_NOTICE'	=> 'Etapa %1$s, Sección %2$s de %3$s, Parte %4$s de %5$s se ha completado, pero hay más secciones y / o partes que deben ser terminados antes de que el convertidor este terminado para esta etapa.<br />Haga clic en Continuar abajo si no se redirigen automáticamente a la página siguiente.',
	'UPGRADE_COMPLETE'				=> 'El proceso de actualización se ha completado correctamente!<br />Por favor, asegúrese de obtener copias de seguridad de su conversión terminado y verificación sobre la configuración y los datos de conversión para asegurarse de que es correcta.',
	'UPGRADE_LIST'					=> 'Lista de actualización',
	'UPGRADE_PHP'					=> 'Está ejecutando una versión de PHP no compatible. Usted debe estar ejecutando PHP 5.1.0 o superior para usar esta modificación.',
	'UPGRADE_REPLIES'				=> 'Actualizar respuestas',

	'WELCOME_MESSAGE'				=> 'Bienvenidos al Mod blog del usuario!

TRADUCIDO POR http://www.tu-webgratis.com/foros/ "CREAMOS TU PAGINA WEB GRATIS"

Lanzamiento del Tema:
http://lithiumstudios.org/forum/viewtopic.php?f=41&t=433

Soporte por el autor sólo se dará en lithiumstudios.org.

Si usted tiene algún comentario o necesita soporte de apoyo en este foro:
http://www.lithiumstudios.org/forum/viewforum.php?f=57

Por favor, compruebe el foro del Mod de usuarios . para información antes de solicitar el apoyo.
http://www.lithiumstudios.org/forum/viewforum.php?f=41',
	'WELCOME_SUBJECT'				=> 'Bienvenidos al Mod blog del usuario!',
));

?>